--[[
Description: This plugin is part of the "Titan Panel [Attributes] Multi" addon. It shows your Armor.
Site: http://www.curse.com/addons/wow/titan-panel-attributes-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "TITAN_ARMRM"
local amr = 0
local startattribute = 0
-----------------------------------------------
local function OnUpdate(self, id)
	local base, total, bonus, minus = UnitResistance("player", 0)
--	local armadura = (base and base + bonus + minus) or 0;

	if amr == total then return end
	amr = total

	TitanPanelButton_UpdateButton(id)
	return true
end
-----------------------------------------------
local function GetButtonText(self, id)
	local BarBalanceText = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (amr - startattribute) > 0 then
			BarBalanceText = " |cFF69FF69["..(amr - startattribute).."]"
		elseif (amr - startattribute) < 0 then
			BarBalanceText = " |cFFFF2e2e["..(amr - startattribute).."]"
		end
	end

	local armortext = "|cFFFFFFFF"..amr.." ("..(string.format("%.2f", (amr / (amr + 7390)) * 100)) .."%)"

	return L["armor"]..": ", armortext..BarBalanceText
end
-----------------------------------------------
local function GetTooltipText(self, id)
	local text = TitanUtils_GetHighlightText("0")

	local dif = amr - startattribute
	if dif > 0 then
		text = "|cFF69FF69"..(amr - startattribute)
	elseif dif < 0 then
		text = "|cFFFF2e2e"..(amr - startattribute)
	end

	return L["tooltipDescriptionExa"]..L["armor"].."|r.\r"..L["session"]..text..L["armorpc"].."|cFFFFFFFF"..(string.format("%.2f", (amr / (amr + 7390)) * 100)).."%"
end
-----------------------------------------------
local eventsTable = {
	PLAYER_ENTERING_WORLD = function(self)
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self.PLAYER_ENTERING_WORLD = nil

		startattribute = UnitArmor("player") or 0
		amr = startattribute

		TitanPanelButton_UpdateButton(self.registry.id)
	end
}
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFf9251a "..L["armor"].."|r".." Multi",
	tooltip = L["armor"],
	icon = "Interface\\Icons\\inv_chest_plate05",
	category = "Combat",
	version = version,
	onUpdate = OnUpdate,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareAttributesMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	},
	eventsTable = eventsTable
})
